<?php

/*
 * $Id: install_sqlite.php 99 2007-08-09 12:49:57Z daniel $
 */

/*
 * yabs - yet another blog system
 * Copyright (C) 2007 Daniel Triendl
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

$querys = array();

$querys[] = "CREATE TABLE " . TABLE_BLOG . " (
  entry_id INTEGER AUTOINCREMENT,
  user_id int(11) NOT NULL default '1',
  entry_date int(11) default '0',
  entry_title varchar(255) NOT NULL,
  entry_content longtext NOT NULL,
  entry_extended longtext,
  link_id int(11) default '1',
  entry_nofeedback int(1) default '0',
  entry_hidden int(1) default '0',
  comment_number int(11),
  PRIMARY KEY  (entry_id)
);";

$querys[] = "INSERT INTO " . TABLE_BLOG . " (user_id, entry_date, entry_title, entry_content, link_id) VALUES
('1', '" . time_utc() . "', 'Welcome to your blog!', 'This is your first entry. Login to the <a href=\"admin.php\">Adminpanel</a> to start blogging.<br /><br />We hope you will enjoy your new blog.',  '1');";

$querys[] = "CREATE TABLE " . TABLE_COMMENTS . " (
  comment_id INTEGER AUTOINCREMENT,
  entry_id int(11) NOT NULL default '0',
  comment_author_name varchar(30) NOT NULL,
  comment_author_mail varchar(50) NOT NULL,
  comment_title varchar(255),
  comment_content text NOT NULL,
  comment_author_ip varchar(15) NOT NULL,
  comment_author_hostname varchar(255) NOT NULL,
  comment_author_url varchar(75),
  comment_date int(11) default '0',
  comment_active int(1) default '0',
  comment_spam int(1) default '0',
  comment_crypt varchar(32),
  PRIMARY KEY  (comment_id)
);";

$querys[] = "CREATE TABLE " . TABLE_CONFIG . " (
  config_name varchar(255) default '',
  config_value varchar(255) default ''
);";

$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('language', 'german')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('template', 'CrystalX')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('blog_title', '')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('blog_subtitle', '')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('limit_blog_entries', '5')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('time_offset', '0')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('time_format', '%m-%d-%Y %H:%M')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('activate_comments', '1')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('accept_trackback', '1')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('version', '" . $yabs_installer_version . "')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('mod_rewrite', '0')";
$querys[] = "INSERT INTO " . TABLE_CONFIG . " (config_name, config_value) VALUES ('delete_spam', '-1');";

$querys[] = "CREATE TABLE " . TABLE_LINKS . " (
  link_id INTEGER AUTOINCREMENT,
  link_name varchar(255),
  link_url varchar(255),
  PRIMARY KEY  (link_id)
);";

$querys[] = "INSERT INTO " . TABLE_LINKS . " (link_name, link_url) VALUES  ('Default', '')";
$querys[] = "INSERT INTO " . TABLE_LINKS . " (link_name, link_url) VALUES ('Dani Bloggt!', 'http://dani.tac-ops.net')";
$querys[] = "INSERT INTO " . TABLE_LINKS . " (link_name, link_url) VALUES ('yabs', 'http://yabs.tac-ops.net');";

$querys[] = "CREATE TABLE " . TABLE_MENU . " (
  menu_id INTEGER AUTOINCREMENT,
  menu_name varchar(255),
  menu_url varchar(255),
  menu_order tinyint(4),
  PRIMARY KEY  (menu_id)
);";

$querys[] = "INSERT INTO " . TABLE_MENU . " (menu_name, menu_url, menu_order) VALUES 
('Home', 'http://" . $_SERVER['HTTP_HOST'] . substr( dirname( $_SERVER['PHP_SELF'] ), 0, strlen( dirname( $_SERVER['PHP_SELF'] ) )-7 ) . "', 1);";

$querys[] = "CREATE TABLE " . TABLE_PLUGINS . " (
  plugin_name varchar(255),
  plugin_version varchar(8)
);";

$querys[] = "CREATE TABLE " . TABLE_USER . " (
  user_id INTEGER AUTOINCREMENT,
  user_name varchar(255),
  user_password varchar(32),
  user_mail varchar(255),
  user_cookie varchar(32),
  user_ip varchar(15),
  user_session varchar(32) default NULL,
  PRIMARY KEY  (user_id)
);";

$querys[] = "CREATE TABLE " . TABLE_USER_CONFIG . " (
  user_id int(11),
  user_config_name varchar(255),
  user_config_value varchar(255),
  user_permission tinyint(1)
);";

$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES  (1, 'use_wysiwyg', '1', '0')";
$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES (1, 'user', '', '1')";
$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES (1, 'settings', '', '1')";
$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES (1, 'links', '', '1')";
$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES (1, 'plugins', '', '1')";
$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES (1, 'entry_other', '', '1')";
$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES (1, 'comments', '', '1')";
$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES (1, 'entry', '', '1')";
$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES (1, 'fm_upload', '', '1')";
$querys[] = "INSERT INTO " . TABLE_USER_CONFIG . " (user_id, user_config_name, user_config_value, user_permission) VALUES (1, 'fm_modify', '', '1');";


?>
